import request from '@/utils/request'




// 专业库-所有专业
export function allMajor(params) {
  return request({
    url: '/front/major/getAllMajor',
    method: 'get',
    params:params
  })
}

// 专业库-专业详情--专业概况
export function getMajorOverviewByCode(params) {
  return request({
    url: '/front/major/getMajorOverviewByCode',
    method: 'get',
    params:params
  })
}

// 专业库-专业详情--就业前景
export function getMajorCareerProspectsByCode(params) {
  return request({
    url: '/front/major/getMajorCareerProspectsByCode',
    method: 'get',
    params:params
  })
}

// 专业库-专业详情--专业概况+就业前景 ======= 批量
export function getMajorDetailByCodes(params) {
  return request({
    url: '/front/major/getMajorDetailByCodes',
    method: 'get',
    params:params
  })
}

// 专业库-专业大类
export function getProfesslibData(params) {
  return request({
    url: '/front/marjors/list',
    method: 'get',
    params:params
  })
}

// 专业库详情
export function getProfesslibDetails(params) {
  return request({
    url: 'front/marjors/detail',
    method: 'get',
    params:params
  })
}


// 获取推荐志愿表头
export function getVoluntaryHeaders(params) {
  return request({
    url: 'front/syzy/zytb/getVoluntaryHeaders',
    method: 'get',
    params:params,
  })
}
// 获取推荐志愿
export function getRecommendVoluntary(data,params) {
  return request({
    url: 'front/syzy/zytb/getRecommendVoluntary',
    method: 'post',
    data:data,
    params:params,
  })
}

// 获取推荐志愿明细
export function getVoluntaryMarjors(data) {
  return request({
    url: 'front/syzy/zytb/getVoluntaryMarjors',
    method: 'post',
    data:data,
  })
}
// 保存志愿
export function saveZhiyuan(data) {
  return request({
    url: 'front/syzy/zytb/save',
    method: 'post',
    data:data,
  })
}

export function getVoluntaryData() {
  return request({
    url: 'front/syzy/zytb/getVoluntaryData',
    method: 'get'
  })
}
