import conditionObjectBase from '../condition-object-base.js'
import classTreeMixin from '@/components/Cache/modules/mx-classTree-translate-mixin'
import { getAllGradeClasses } from '@/api/webApi/grade'
export default {
  mixins: [classTreeMixin],
  ...conditionObjectBase,
  key: 'localClassId',
  title: '原班级',
  getList: function(param, $vue) {
    return new Promise((resolve,reject) => {
      getAllGradeClasses().then(res =>{
        // 暂时写死
        console.log($vue.model.queryLocalYear)
        console.log(res.data)
        const data = res.data.find(item => item.year == $vue.model.queryLocalYear).classList
        resolve(data)
      }).catch(
        e => reject(e)
      )
    })
  },
  getCode: function(item) {
    return item.classId
  },
  getLabel: function(item) {
    return item.className
  }
}
