import conditionObjectBase from '../condition-object-base.js'
import {
  smartGradeList,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  dependentKeys: ['exeOrder'],
  isDependencyReady(params) {
    return params.exeOrder
  },
  key: 'exeGrade',
  title: '学册',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      smartGradeList({subjectId:$ref.model.exeSubject,editionId:param.exeOrder}).then(res => resolve(res.data  || []))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item.gradeid
  },
  getLabel: function(item) {
    return item.gradename
  }
}
