import conditionObjectBase from '../condition-object-base.js'
import {
  newEditionList,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  dependentKeys: ['exeSubject'],
  isDependencyReady(params) {
    return params.exeSubject
  },
  key: 'exeOrder',
  title: '版本',
  getList: function(param,) {
    return new Promise((resolve, reject) => {
      newEditionList({subjectId:param.exeSubject}).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item.id
  },
  getLabel: function(item) {
    return item.name
  }
}
