import conditionObjectBase from '../condition-object-base.js'
import {
  smartSubjectList,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  key: 'exeSubject',
  title: '科目',
  getList: function(param) {
    return new Promise((resolve, reject) => {
      smartSubjectList().then(res => resolve(res.rows))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item.subjectid
  },
  getLabel: function(item) {
    return item.subjectname
  }
}
