import conditionObjectBase from '../condition-object-base.js'
import { favQueTypes } from '@/api/webApi/webQue'
export default {
  ...conditionObjectBase,
  isDependencyReady(params) {
    return params.favSubject
  },
  dependentKeys: ['favSubject'],
  key: 'favQueType',
  title: '题型',
  getList: function(param) {
    return new Promise((resolve, reject) => {
      favQueTypes({
        subjectName:param.favSubject
      }).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
