import conditionBase from '../condition-object-base'

export default {
  ...conditionBase,
  key: 'favCollectType',
  title: '类型',
  getList: function(param, $vue) {
    return this._getList(param, $vue)
  },
  _getList: function(param, $vue) {
    return Promise.resolve( [
      { type: 'question', name: '试题收藏' },
      { type: 'paper', name: '试卷收藏' }
    ])
  },
  getCode(item) {
    return item.type
  },
  getLabel(item) {
    return item.name
  }
}
