import conditionObjectBase from '../condition-object-base.js'
import {
  papersAreas,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  isDependencyReady(params) {
    return params.paperType
  },
  dependentKeys: ['paperType'],
  key: 'paperArea',
  title: '地区',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      papersAreas({
        subjectName:$ref.model.paperSubject,
        gradeName:$ref.model.paperGrade,
        gradeType:param.paperType,
      }).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
