import conditionObjectBase from '../condition-object-base.js'
import {
  paperGrade,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  isDependencyReady(params) {
    return params.paperSubject
  },
  dependentKeys: ['paperSubject'],
  key: 'paperGrade',
  title: '年级',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      paperGrade({subjectName:param.paperSubject}).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
