import conditionObjectBase from '../condition-object-base.js'
import {
  papersTypes,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  isDependencyReady(params) {
    return params.paperGrade
  },
  dependentKeys: ['paperGrade'],
  key: 'paperType',
  title: '类型',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      papersTypes({subjectName:$ref.model.paperSubject,gradeName:param.paperGrade}).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
