import conditionObjectBase from '../condition-object-base.js'
import config from '@/common/mx-config'

export default {
  ...conditionObjectBase,
  key: 'releaseGeneration',
  title: '选科状态',
  getList: function() {
    return new Promise((resolve, reject) => {
      const dmGenerations = Object.values(config.electiveGenerationOptions)
        .filter(opt => opt.decisionMaking && opt.stepsVisible)
        .map(opt => ({ name: opt.title, id: opt.value }))
      resolve(dmGenerations)
    })
  }
}
