import conditionObjectBase from '../condition-object-base.js'
import {
  selectUniversityTypes,
} from '@/api/webApi/shiftLine'

// 院校投档线  科类
export default {
  ...conditionObjectBase,
  dependentKeys: ['lineYear'],
  key: 'lineType',
  isDependencyReady(params) {
    return params.lineYear
  },
  title: '科类',
  getList: function(param) {
    return new Promise((resolve, reject) => {
      selectUniversityTypes({
        year: param.lineYear
      }).then(res => resolve(res.rows))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
