import conditionObjectBase from '../condition-object-base.js'
import * as system from "@/api/webApi/system";

export default {
  ...conditionObjectBase,
  key: 'subjectByVideo',
  title: '科目',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      system.getSubjectsList({  }).then(res => resolve(
        res.rows.map(item => {
          return {
            code: item.subjectid,
            label:item.subjectname
          }
        })
      ))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item.code
  },
  getLabel: function(item) {
    return item.label
  }
}
