import subjectBase from './condition-video-subject'
import { videoSubjects } from '@/api/webApi/webVideo'

export default {
  ...subjectBase,
  key: 'videoCourseFixed',
  dependentKeys: [],
  isDependencyReady(params) {
    return true
  },
  getList: function(param,$ref) {
    console.log($ref.model.videoTypeFixed)
    return new Promise((resolve, reject) => {
      videoSubjects({ subject:$ref.model.videoTypeFixed }).then(res => resolve(
        res.rows.map(item => {
          return {
            code: item.code,
            label:item.label
          }
        })
      ))
        .catch(e => reject(e))
    })
  },
}
