import conditionObjectBase from '../condition-object-base.js'
import {
  wrongTypes,
} from "@/api/webApi/webQue.js";
export default {
  ...conditionObjectBase,
  key: 'wrongType',
  title: '题型',
  dependentKeys: ['wrongSubject'],
  getList: function(param) {
    return new Promise((resolve, reject) => {
      wrongTypes({
        subjectName:param.wrongSubject }).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
