export default {
  methods: {
    forceAdjustResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        item.adjustRecord = `${currentGroup.groupApprovedCount + currentGroup.groupForceAdjustedCount} /${currentGroup.personCount}`
        item.adjustIndicator = currentGroup.groupApprovedCount + currentGroup.groupForceAdjustedCount - currentGroup.personCount
      })
      return {
        adjustRecord: {
          label: '调剂补录情况'
        },
        adjustIndicator: {
          label: '调剂补录结果',
          slot: 'underOver'
        }
      }
    }
  }
}
