export default {
  methods: {
    primaryDMResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        item.primarySituation = currentGroup.preferenceOverflow
      })

      if (activeModel.generation < 4) {
        return {
          primarySituation: {
            label: '超/缺',
            slot: 'underOver'
          }
        }
      } else {
        return {}
      }

    }
  }
}
