const Mock = require('mockjs')

module.exports = [
  {
    url: '/mock/front/dispatch/getClass',
    type:'get',
    response: config => {
      return {
        code: 200,
        msg: 'success',
        data:
          [{
            classId: 1,
            className:202,
          },{
            classId: 2,
            className:203,
          },
            {
              classId: 3,
              className:204,
            }
          ]

      }
    }
  },
  {
    url: '/mock/front/dispatch/getHeadteacherDispatchSettings',
    type:'get',
    response: config => {
      return {
        code: 200,
        msg: 'success',
        data: {
          '405': {
            headteacherCode: '01cb6829eb9e4e7d95064a5a6d6174e8',  // 老师用户ID
            nickName: '王铭传' // 老师称乎
          },
          '406': {
            headteacherCode: '72b034d5ee7642ae90af044098f524ff',  // 老师用户ID
            nickName: '曾老师' // 老师称乎
          }
        }
      }
    }
  },
]
