import request from '@/utils/request'

// /prod-api/front/ai/getAiVideos // AI匹配视频
export function getAiVideos(params) {
  return request({
    url: '/front/ai/getAiVideos',
    method: 'get',
    params: params
  })
}

// /front/ai/getApiPaperStatus  // AI匹配试题探测，该继续OR重新来？
export function getApiPaperStatus(params) {
  return request({
    url: '/front/ai/getApiPaperStatus',
    method: 'get',
    params: params
  })
}

// /prod-api/front/ai/getAiPapers
// 10 AI考卷列表 knowledges*requires
export function getAiPapers(params) {
  return request({
    url: '/front/ai/getAiPapers',
    method: 'get',
    params: params
  })
}

// /prod-api/front/ai/getAiPaper
// 01 AI考卷详解 paperId*requires
export function getAiPaper(params) {
  return request({
    url: '/front/ai/getAiPaper',
    method: 'get',
    params: params
  })
}
