import request from '@/utils/request'

//  学生卡价格列表
export function getEcardPrices() {
  return request({
    url: 'front/ecard/getEcardPrices',
    method: 'get',
  })
}

//  验证码
export function sendSmsNoValidation(params) {
  return request({
    url: 'common/shortMessage/sendSmsNoValidation',
    method: 'get',
    params
  })
}

export function validateSms(params) {
  return request({
    url: 'common/shortMessage/validateSms',
    method: 'get',
    params
  })
}

// front/ecard/prepayCard
export function prepayCard(params) {
  return request({
    url: 'front/ecard/prepayCard',
    method: 'get',
    params
  })
}

export function regenerateQrCode(params) {
  return request({
    url: 'front/ecard/regenerateQrCode',
    method: 'get',
    params
  })
}

export function getOrderPayStatus(params) {
  return request({
    url: 'front/ecard/getOrderPayStatus',
    method: 'get',
    params
  })
}
