import cacheMixin from '@/components/Cache/mx-cache-mixin.js'

export default {
  mixins: [cacheMixin],
  data() {
    return {
      vocationList: [],
      vocationIsReady: false
    }
  },
  beforeMount() {
    this.loadVocationTree()
  },
  methods: {
    async loadVocationTree() {
      this.vocationList = await this.getAllVocationTree()
      this.vocationIsReady = true
      console.log('vocation-ready')
    },
  }
}
