import conditionObjectBase from '../condition-object-base.js'
import { favSubjects } from '@/api/webApi/webQue'
export default {
  ...conditionObjectBase,
  isDependencyReady(params) {
    return params.favCollectType
  },
  dependentKeys: ['favCollectType'],
  key: 'favSubject',
  title: '学科',
  getList: function(param) {
    return new Promise((resolve, reject) => {
      favSubjects({
        type:param.favCollectType
      }).then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
