import conditionObjectBase from '../condition-object-base.js'
import {
  subjectList,
} from '@/api/webApi/webQue.js'

export default {
  ...conditionObjectBase,
  key: 'paperSubject',
  title: '科目',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      subjectList().then(res => resolve(res.data))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
