import conditionObjectBase from '../condition-object-base.js'
import {
  selectUniversityYears
} from '@/api/webApi/shiftLine'

// 院校投档线  年份
export default {
  ...conditionObjectBase,
  key: 'lineYear',
  title: '年份',
  getList: function(param) {
    return new Promise((resolve, reject) => {
      selectUniversityYears().then(res => resolve(res.rows))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item
  },
  getLabel: function(item) {
    return item
  }
}
