import conditionObjectBase from '../condition-object-base.js'
import {
  videoType,
} from "@/api/webApi/webVideo";

export default {
  ...conditionObjectBase,
  key: 'videoType',
  title: '类型',
  getList: function(param,$ref) {
    return new Promise((resolve, reject) => {
      videoType().then(res => resolve(res.rows))
        .catch(e => reject(e))
    })
  },
  getCode: function(item) {
    return item.code + ''
  },
  getLabel: function(item) {
    return item.label
  }
}
