export default {
  methods: {
    commonAIResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        const disenrollAll = model.disenrollCount
        item.localGroupIndicator = model.option.decisionMaking ? currentGroup.nextGroupIndicator : currentGroup.groupIndicator
        item.localBestInIndicator = currentGroup.bestInIndicator || '-'
        item.localRankInBest = currentGroup.rankInBest ? `${currentGroup.rankInBest}/${currentGroup.bestInIndicator}` : '-'
        item.localRankInDisenroll = currentGroup.rankInDisenroll ? `${currentGroup.rankInDisenroll}/${disenrollAll}` : '-'
        item.localRankInRecommend = currentGroup.rankInIndicator ? `${currentGroup.rankInIndicator}/${item.localGroupIndicator}` : '-'
      })
    }
  }
}
