export default {
  methods: {
    forceAdjustAIResolver(model, activeModel, context) {
      const prevModel = activeModel.prevModel
      const prevResolverKey = prevModel.option.key + 'AIResolver'
      if (typeof this[prevResolverKey] === 'function') {
        return this[prevResolverKey](model, activeModel, context)
      }
      return {}
    }
  }
}
