export default {
  methods: {
    backTrackingResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        item.backTrackingApply = `${currentGroup.actualCount} /${currentGroup.groupIndicator}`
      })

      if (activeModel.generation < 4) {
        return {
          backTrackingApply: {
            label: '补录报名情况'
          }
        }
      } else {
        return {}
      }
    }
  }
}
