export default {
  methods: {
    backTrackingDMResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        item.supplyIndicator = currentGroup.preferenceOverflow
        item.backTrackingApply = `${currentGroup.groupApprovedCount } /${currentGroup.personCount}`
      })

      return {
        applyCount: {
          label: '初录情况'
        },
        primarySituation: {
          label: '初录超缺',
          slot: 'underOver'
        },
        backTrackingApply: {
          label: '补录情况' // 补录情况 =
        },
        supplyIndicator: {
          label: '补录结果', // 补录的超缺
          slot: 'underOver'
        }
      }
    }
  }
}
