export default {
  methods: {
    finalAdjustDMResolver(model, activeModel, context) {
      const models = model?.models || []
      this.formatRows.forEach(item => {
        const currentGroup = models.find(group => group.groupId == item.groupId) || {}
        item.finalAdjustApply = `${currentGroup.groupApprovedCount } /${currentGroup.personCount}`
        item.towSupplyIndicator = currentGroup.preferenceOverflow
      })
      return {
        finalAdjustApply:{
          label:'二次补录情况'
        },
        towSupplyIndicator:{
          label:'二次补录结果',
          slot: 'underOver'
        }
      }
    }
  }
}
