export default {
  inject: {
    loginCheck: {
      default: function() {
        // 首页用到的block均需要混入此mixin
        // 目的在于形成统一的点击响应

        // 默认通过，因为block组件可能不止在首页使用
        // 不同的嵌入块可以由容器注入不同的校验逻辑
        return () => true
      }
    }
  }
}
